#include <bits/stdc++.h>

using namespace std;

vector<int> res;
int a[500010];

void rek(int l, int d, int k)
{
    if(k == 0) return;
    int mini = INT_MAX;
    int ind = 0;
    for(int i = l; i <= d - k + 1; i++)
    {
        if(a[i] < mini)
        {
            mini = a[i];
            ind = i;
        }
    }
    res.push_back(mini);
    rek(ind + 1, d, k - 1);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];

    rek(0, n-1, n-k);
    for(int i = 0; i < res.size(); i++) cout << res[i] << " ";

    return 0;
}